--
-- ADVance MS model for electromechanical harvesting_resonator adms_vhdlams_ESYCOM_juine2007
--
LIBRARY DISCIPLINES;
USE DISCIPLINES.ELECTROMAGNETIC_SYSTEM.ALL;
library IEEE;
use IEEE.MATH_REAL.all;



ENTITY capa_variable IS
	GENERIC(
          frequency:real:=100.0; --capacitance variation frequency
          Cmax:real:=200.0e-12; --Cmax
          Cmin:real:=100.0e-12; --Cmin
          phi0:real:=0.0; -- initial phase
		Q0:real:=0.0 --initial charge
		);

     -- les terminaux : C1 et C2 are the capacitor's electrodes 
	PORT (
		TERMINAL C1        : Electrical ;
          TERMINAL C2      : Electrical 
	);
END;

ARCHITECTURE sinusoidal_model OF capa_variable IS



quantity charge:real:=0.0;
quantity uC across iC through C1 to C2; -- the capacitor voltage
quantity Cvar:real;
BEGIN
charge==iC'integ+Q0;
Cvar==(Cmax+Cmin)/2.0+(Cmax-Cmin)/2.0*sin(2.0*3.1415926*frequency*now+phi0);
uC==charge/Cvar;
-- that's all... 
END;
