--
-- ADVance MS model for electromechanical_rodrigo diode_ideale adms_vhdlams_exponential
--
LIBRARY DISCIPLINES,IEEE;
USE DISCIPLINES.ELECTROMAGNETIC_SYSTEM.ALL;
USE IEEE.MATH_REAL.ALL;
ENTITY diode_ideale_adms_vhdlams_exponential IS
	PORT (
		TERMINAL ep         : Electrical ;
		TERMINAL em         : Electrical 
	);
END;

ARCHITECTURE adms_vhdlams_exponential OF diode_ideale_adms_vhdlams_exponential IS
quantity vc across ic through ep to em;
constant I0:real:=1.0e-13;
constant e:real:=1.6e-19;
constant T:real:=300.0;
--constant k:real:=1.38e-24; -- for ~0 Vd
constant k:real:=1.38e-23; -- for Vd ne 0
constant Imax:real:=1.0;


BEGIN
if vc<k*T/e*log((Imax+I0)/I0)/log(exp(1.0)) use ic==I0*(exp(e*vc/(k*T))-1.0); 
else ic==Imax+e/(k*T)*(Imax+I0)*(vc- k*T/e*log((Imax+I0)/I0 )/log(exp(1.0)));
end use;
--break on vc'above(k*T/e*log((Imax+I0)/I0)/log(exp(1.0)));
END architecture adms_vhdlams_exponential;



